<?php

	define('IN_PARTS', true);

	/* Set up environment */
	error_reporting(E_ALL);
	setlocale(LC_ALL,
		'de_DE@euro.UTF8', 'de_DE@euro.UTF-8',
		'de_DE.UTF8', 'de_DE.UTF-8',
		'de.UTF8', 'de.UTF-8',
		'ge.UTF8', 'ge.UTF-8',
		'de_DE@euro', 'de_DE', 'de', 'ge'
	);


	require 'config.php';
	require 'template.php';
	require 'database.php';


	/* Connect to database */
	$Db = new Database($db_config);
	unset($db_config);


	/* Set up basic template */
	$Tpl = new ClientXSLTemplate();
	echo '<date>' . strftime('%d. %B %Y, %H:%M') . '</date>';
	echo '<toolbar>';
	echo '<link id="index">index.php</link>';


	/* Try to authenticate the user */
	if (!isset($_GET['logout']) && isset($_SERVER['PHP_AUTH_USER']) && isset($_SERVER['PHP_AUTH_PW'])) {
		/* Validate user and password */
		$rs = $Db->query('SELECT * FROM users WHERE username = \'' .
			$Db->escape($_SERVER['PHP_AUTH_USER']) . '\' AND pw = \'' .
			$Db->escape($_SERVER['PHP_AUTH_PW']) . '\' LIMIT 1'
		);

		$User = $Db->fetch($rs);
		$Db->free($rs);

		if ($User !== false) {
			define('AUTHENTICATED', true);
		}
	}


	if (!defined('AUTHENTICATED')) {
		header('WWW-Authenticate: Basic realm="PartsDB"');
		header('HTTP/1.0 401 Unauthorized');

		echo '</toolbar>';
		$Action = 'unauthenticated';
		$Tpl->render('unauthenticated.xsl');
		exit;
	}


	require 'common.php';
	$Url = new Url();

	/* Extend toolbar */
	echo '<link id="logout">index.php?logout=y</link>';
	echo '<link id="stock">' . $Url->build('stock') . '</link>';
	echo '</toolbar>';


	$actions = array(
		'index',
		'stock',
		'part',
		'edit-model',
		'edit-resources');

	if ( ($Action = param('ac')) !== NULL ) {
		if (!in_array($Action, $actions)) {
			$Action = 'index';
		}
	}
	else {
		$Action = 'index';
	}

	unset($actions);

	require 'pa-' . $Action . '.php';
?>