<?php

	if (!defined('IN_PARTS')) {
		exit;
	}




	/* Try to identify model or category */
	$creating = false;
	if ( ($part_id = param('id')) === NULL ) {
		message('info',
			'Kein Modell zur Bearbeitung angegeben.',
			'default'
		);
		return;
	}

	$part_id = intval($part_id);

	/* Find part */
	$rs = $db->query(<<<ENDSQL
SELECT
	c.title,
	c.id
FROM
	`parts` p
	INNER JOIN `categories` c
		ON c.id = p.category_id
WHERE
	p.id = {$part_id}
LIMIT 1
ENDSQL
	);

	$category = $db->fetch($rs);
	$db->free($rs);

	if ($category === false) {
		message('alert',
			'Das Bauteil existiert nicht.',
			'default'
		);
		return;
	}

	$url->set('id', $part_id);
?>

<div class="title"><img alt="Lager" src="images/16-part.png" />
	<?php echo htmlspecialchars($category['title']); ?> &mdash; Ressourcen bearbeiten
</div>

<div class="cobox">
	<div class="title">
		<img alt="Ressourcen" src="images/16-resources.png" />
		Ressourcen</div>

<form action="index.php" method="post">
	<table style="width: 100%;" class="catalog">
		<tr>
			<th>Kommentar</th>
			<th style="width: 20%;">Herunterladen</th>
			<th style="width: 48px;"></th>
		</tr>

<?php
	$drop_id = NULL;

	$attach_status = NULL;
	$attach_form = array(
		'comment' => array(NULL, ''),
		'type' => array(NULL, 'link'),
		'link' => array(NULL, ''),
		'file' => array(NULL, '')
	);


	if (isset($_GET['drop'])) {
		$drop_id = intval($_GET['drop']);

		$db->query('DELETE FROM `attachments` WHERE' .
			" `resource_id` = {$drop_id} AND `part_id` = {$part_id} LIMIT 1");

		if (!$db->effect()) {
			$drop_id = NULL;
		}
	}
	elseif (isset($_POST['attach'])) {
		$attach_form['comment'][0] = isset($_POST['comment']);
		if ($attach_form['comment'][0]) {
			$attach_form['comment'][1] = $_POST['comment'];
		}

		$attach_form['type'][0] = isset($_POST['type']);
		if ($attach_form['type'][0]) {
			if ( ($_POST['type'] == 'link') || ($_POST['type'] == 'remote') ) {
				$attach_form['type'][1] = $_POST['type'];

				$attach_form['link'][0] = isset($_POST['link']);
				if ($attach_form['link'][0]) {
					$attach_form['link'][1] = trim($_POST['link']);

					if ($attach_form['link'][1] == '') {
						$attach_form['link'][0] = false;
					}
				}
			}
			elseif ($_POST['type'] == 'file') {
				$attach_form['type'][1] = 'file';

				$attach_form['file'][0] = isset($_POST['file']);
				if ($attach_form['file'][0]) {
					$attach_form['file'][1] = $_POST['file'];

					if (!preg_match('/^\s*([0-9]+)\s*$/', $attach_form['file'][1], $matches)) {
						$attach_form['file'][0] = false;
					}
					else {
						$attach_form['file'][1] = $matches[1];
					}
				}
			}
			else {
				$attach_form['type'][0] = false;
				$attach_form['type'][1] = 'link';
			}
		}

		$attach_status = true;
		foreach ($attach_form as $field) {
			if ($field[0] === false) {
				$attach_status = false;
				break;
			}
		}


		if ($attach_status) {
			$sql =
				'INSERT INTO `resources` (`type`, `file`, `status`, `comment`)' .
		 		" VALUES ('{$attach_form['type'][1]}'";

			if ($attach_form['type'][1] == 'file') {
				$sql .= ', \'\', NULL';
			}
			else {
				$sql .= ', \'' . $db->escape($attach_form['link'][1]) . '\'' .
					'\'unknown\'';
			}

			$sql .= ', NULL)';
			$db->query($sql);
			$resource_id = $db->id();

			/* Attach the resource */
			$db->query(
				'INSERT INTO `attachments` (`part_id`, `resource_id`, `comment`)' .
				" VALUES({$part_id}, {$resource_id}," .
				' \'' . $db->escape($attach_form['comment'][1]) . '\')'
			);
		}
	}


	$rs = $db->query(<<<ENDSQL
SELECT
	r.id,
	r.type,
	r.file,
	r.status,
	r.size,
	r.date,
	r.comment AS `resource_comment`,
	a.comment
FROM
	`attachments` a
	INNER JOIN `resources` r
		ON r.id = a.resource_id
WHERE
	a.part_id = {$part_id}
ENDSQL
);


	$flag = false;
	while ( ($resource = $db->fetch($rs)) !== false ) {
		echo '<tr class="' . (($flag) ? 'even' : 'odd') . '"><td>';
		$flag = !$flag;

		if ($resource['resource_comment'] !== NULL) {
			echo '<img alt="Kommentar zur Ressource" src="images/12-resource.png" />' .
				htmlspecialchars($resource['resource_comment']) . '<br />';
		}

		echo '<input name="co' . $resource['id'] . '" type="text" size="50"' .
			' value="' . htmlspecialchars($resource['comment']) . '" />';
		echo '</td><td>';

		switch ($resource['type']) {
			case 'file':
				echo '<a href="download.php?id=' . $resource['id'] . '">' .
					htmlspecialchars($resource['file']) . '</a>';
				break;

			case 'remote':
				echo '<a href="' . htmlspecialchars($resource['file']) . '">' .
					'von extern</a>';
				break;

			case 'link':
				echo '<a href="' . htmlspecialchars($resource['file']) . '">' .
					'besuchen</a>';
				break;
		}

		echo '</td><td>';
		echo '<a href="' . $url->build('drop', $resource['id']) . '">' .
			'<img alt="Löschen" src="images/16-drop.png" /></a>';
		echo '</td></tr>';
	}

	$db->free($rs);
?>

	</table>

	<table class="form">

<?php
	if ($drop_id !== NULL) {
		table_message('info',
			'Ressource wurde abgehängt.'
		);
	}
?>

		<tr>
			<th />
			<td>
				<input name="update" type="submit" value="Übernehmen" />
				<input type="reset" value="Zurücksetzen" />

<?php
	echo '<a href="' . $url->build('part') . '">Zurück zum Bauteil</a> oder ';
	echo '<a href="' . $url->buildBase('stock', 'cat', $category['id']) . '">zum Lager</a>';

	echo $url->buildForm();
?>

			</td>
		</tr>
	</table>
</form>

<br />

<form action="index.php" method="post">
	<table style="margin: auto;">
		<tr>
			<th />
			<th>Neue Ressource anhängen</th>
		</tr>
		<tr>
			<th>Kommentar zur Ressource</th>
			<td>
				<input type="text" name="comment" size="50"<?php form_field($attach_form['comment']); ?> />
			</td>
		</tr>
		<tr>
			<th rowspan="2">Inhalt</th>
			<td<?php echo (($attach_form['type'][0] === false) ? ' class="fail"' : ''); ?>>
				<input<?php echo (($attach_form['type'][1] == 'link') ? ' checked="checked"' : ''); ?> type="radio" id="Ltype" name="type" value="link" />
				<label for="Ltype">Verweis zu einer Webseite</label> oder
				<input<?php echo (($attach_form['type'][1] == 'remote') ? ' checked="checked"' : ''); ?> type="radio" id="Rtype" name="type" value="remote" />
				<label for="Rtype">zu externer Datei</label>:<br />

				<input type="text" name="link" size="50"<?php form_field($attach_form['link']); ?> />
			</td>
		</tr>
		<tr>
			<td<?php echo (($attach_form['type'][0] === false) ? ' class="fail"' : ''); ?>>
				<input<?php echo (($attach_form['type'][1] == 'file') ? ' checked="checked"' : ''); ?> type="radio" id="Ftype" name="type" value="file" />
				<label for="Ftype">Interne Datei</label>:<br />

				ID: <input type="text" name="file" size="20"<?php form_field($attach_form['file']); ?> />
			</td>
		</tr>
	</table>

	<table class="form">

<?php
	if ($attach_status === false) {
		table_message('alert',
			'Bitte überprüfen Sie die markierten Eingaben.'
		);
	}
	elseif ($attach_status !== NULL) {
		table_message('info',
			'Ressource wurde hinzugefügt.'
		);
	}
?>

		<tr>
			<th />
			<td>
				<input name="attach" type="submit" value="Anhängen" />

<?php echo $url->buildForm(); ?>

			</td>
		</tr>
	</table>

</form>
</div>
