<?php

	if (!defined('IN_PARTS')) {
		exit;
	}


	/* Try to identify model */
	$model = NULL;
	if (!isset($_GET['id'])) {
		message('info',
			'Kein Bauteil zur Betrachtung angegeben.',
			'Zum Lager gehen', $url->buildBase('stock')
		);
		return;
	}

	$part_id = intval($_GET['id']);

	/* Find module and calculate total stock */
	$rs = $Db->query(<<<ENDSQL
SELECT
	SUM(s.quantity) AS `total_quantity`,
	c.module,
	c.module_arguments,
	c.id,
	c.title,
	p.rohs,
	p.technology
FROM
	`parts` p
	INNER JOIN `categories` c
		ON c.id = p.category_id
	LEFT JOIN `stock` s
		ON s.part_id = p.id AND s.user_id = {$User['id']}
WHERE
	p.id = {$part_id}
GROUP BY
	p.id
LIMIT 1
ENDSQL
		);

	$category = $Db->fetch($rs);
	$Db->free($rs);

	if ($category === false) {
		message('alert',
			'Das Bauteil oder die Kategorie existiert nicht.',
			'Zum Lager gehen', $Url->buildBase('stock')
		);
		return;
	}


	require 'module.php';
	$module = Module::instance($category['module'], $category['module_arguments']);

	if ( ($sql_module_columns = $module->buildSqlColumns()) != '' ) {
		$sql_module_columns = ', ' . $sql_module_columns;
	}

	if ( ($sql_conditions = $module->buildSqlConditions()) != '' ) {
		$sql_conditions = ' AND ' . $sql_conditions;
	}

	$sql_models_table = $module->buildSqlTable();

	/* Find part and total stock */
	$rs = $Db->query(<<<ENDSQL
SELECT
	m.id
	{$sql_module_columns}
FROM
	{$sql_models_table} m
WHERE
	m.id = {$part_id}
	{$sql_conditions}
LIMIT 1
ENDSQL
	);

	$model = $Db->fetch($rs);
	$Db->free($rs);
	if ($model === false) {
		message('alert',
			'Der zum Bauteil gehörende Modelldatensatz existiert nicht oder nicht mehr.',
			'Zum Lager gehen', $Url->buildBase('stock', 'cat', $category['id'])
		);
		return;
	}

	$Url->set('id', $part_id);
?>

<div class="title"><img alt="Lager" src="images/16-part.png" />
<?php echo htmlspecialchars($category['title']); ?>
</div>

<div class="cobox" style="float: left; width: 40%;">
	<div class="title" style="float: left;">
		<img alt="Bauteilparameter" src="images/16-details.png" />
		Bauteilparameter</div>

	<div style="float: right;">
		<a href="<?php echo $Url->build('edit-model'); ?>">
			<img alt="Bearbeiten" src="images/16-edit.png" /></a>
	</div>

	<table style="clear: both; width: 100%;">

<?php
	/* Display model parameters */
	foreach ($module->parameters() as $parameter) {
		echo '<tr><th>' . $parameter->title(true) . '</th>';
		echo '<td>' . $parameter->formatField($model, true) . '</td>';
		echo '</tr>';
	}

	echo '<tr><td colspan="2" style="text-align: right;">';

	if ($category['rohs'] == 'yes') {
		echo '<img alt="RoHS-konform" src="images/rohs.png" />';
	}

	echo '</td></tr>';
?>

	</table>
</div>


<div class="cobox" style="float: right;">
	<div class="title">
		<img alt="Bestand" src="images/16-stock.png" />
		Aktueller Bestand</div>

<?php
	if ($category['total_quantity'] === NULL) {
		echo 'Keine Teile auf Lager.';
	}
	else {
?>

	<table class="catalog" style="width: 100%;">
		<tr>
			<th class="pri" style="width: 75px;">Menge</th>
			<th>Lagerort</th>
		</tr>

<?php
	/* Display stock */
	$rs = $Db->query(<<<ENDSQL
SELECT
	*
FROM
	`stock` s
WHERE
	s.part_id = {$part_id}
	AND s.user_id = {$User['id']}
ORDER BY
	s.quantity DESC
ENDSQL
	);


	$flag = false;
	while ( ($stock = $Db->fetch($rs)) !== false ) {
		echo '<tr class="' . (($flag) ? 'even' : 'odd') . '">';
		$flag = !$flag;

		echo '<td class="pri">' . $stock['quantity'] . '</td>';
		echo '<td style="text-align: left;">' .
			htmlspecialchars($stock['location']) . '</td>';
		echo '</tr>';
	}

	$Db->free($rs);
?>

		<tr>
			<th class="pri" colspan="2">
				Gesamtbestand: <?php echo $category['total_quantity']; ?> Stück
			</th>
		</tr>
	</table>

<?php
	} /* if ($category['total_quantity'] === NULL) */
?>

</div>


<div class="cobox" style="width: 97%; clear: both;">
	<div class="title">
		<img alt="Lieferanten" src="images/16-suppliers.png" />
		Lieferanten</div>

	<table class="catalog" style="width: 100%;">
		<tr>
			<th>Lieferant</th>
			<th>Teilenummer</th>
			<th class="pri">Preis</th>
			<th style="width: 80px;">verfügbar</th>
			<th style="width: 130px;">Stand</th>
			<td style="width: 16px;">&nbsp;</td>
		</tr>

<?php
	if (isset($_GET['query_source'])) {
		$query_source = $_GET['query_source'];
	}
	else {
		$query_source = NULL;
	}

	/* Find suppliers */
	$rs = $Db->query(<<<ENDSQL
SELECT
	su.title AS `supplier_title`,
	su.id AS `supplier_id`,
	so.*
FROM
	`sources` so
	INNER JOIN `suppliers` su
		ON su.id = so.supplier_id
WHERE
	so.part_id = {$part_id}
ORDER BY
	so.date_queried DESC
ENDSQL
	);

	$total_available = 0;
	while ( ($source = $Db->fetch($rs)) !== false ) {
		/* Create a class (for link and price */
		$supplier = Supplier::instance($source['supplier_title']);

		if ($query_source === $source['supplier_id']) {
			/* Query prices and availability */
			$prices = $supplier->findPrices($source['code']);

			if ($prices !== false) {
				store_prices($source['supplier_id'], $prices);
			}
			else {
				clear_prices($source['supplier_id']);
			}
		}


		echo '<tr>';
		echo '<td style="text-align: left;">' .
			htmlspecialchars($source['supplier_title']) . '</td>';

		echo '<td style="text-align: left;"><a href="' .
			$supplier->buildLink($source['code']) . '">' .
			htmlspecialchars($source['code']) . '</a></td>';


		/* Query prices from database */
		$prices_rs = $Db->query(<<<ENDSQL
SELECT
	`title`,
	`price`,
	`currency`
FROM
	`prices`
WHERE
	`part_id` = {$part_id}
	AND `supplier_id` = {$source['supplier_id']}
ORDER BY
	`seq` ASC
ENDSQL
		);


		if (!$Db->void($prices_rs)) {
			echo '<td class="pri"><table style="width: 100%;">';

			while ( ($price = $Db->fetch($prices_rs)) !== false ) {
				echo '<tr><td>' . htmlspecialchars($price['title']) . '</td>';
				echo '<td>' . format_decimal(floatval($price['price']), 4) . '</td>';
				echo '<td style="text-align: left;">' .
					htmlspecialchars($price['currency']) . '</td></tr>';
			}

			echo '</table></td>';

			echo '<td style="vertical-align: bottom;">';
			if ($source['quantity'] !== NULL) {
				$value = $source['quantity'];
				$total_available += $value;
				$magnitude = calculate_magnitude($value);
				echo $value . (($magnitude == '') ? '' : ' ') . $magnitude;
			}
			echo '</td>';

			echo '<td>';
		}
		else {
			echo '<td colspan="3"></td>';
		}

		$Db->free($prices_rs);

		echo '<td><a href="' .
			$Url->build('query_source', $source['supplier_id']) . '">' .
			'<img alt="Aktualisieren" src="images/16-query.png" /></a>';
		echo '</td></tr>';
	}

	$Db->free($rs);
?>

		<tr>
			<th colspan="5" class="pri">

<?php
	if ($total_available > 0) {
		echo 'Mindestens ' . strval($total_available) .' Stück verfügbar';
	}
	else {
		echo 'Keine Informationen zur Verfügbarkeit';
	}
?>

			</th>
			<td />
		</tr>
	</table>
</div>


<div class="cobox" style="width: 60%; clear: both;">
	<div class="title" style="float: left;">
		<img alt="Lieferanten" src="images/16-resources.png" />
		Datenblätter und Ressourcen</div>

	<div style="float: right;">
		<a href="<?php echo $Url->build('edit-resources'); ?>">
			<img alt="Bearbeiten" src="images/16-edit.png" /></a>
	</div>

	<table class="catalog" style="width: 100%;">
		<tr>
			<th>Kommentar</th>
			<th class="pri" style="width: 20%;">Herunterladen</th>
			<th style="width: 10%;">Größe</th>
			<th style="width: 20%;">Datum</th>
			<td style="width: 16px;"></td>
		</tr>

<?php
	if (isset($_GET['query_resource'])) {
		$query_resource = $_GET['query_resource'];
	}
	else {
		$query_resource = NULL;
	}

	$rs = $Db->query(<<<ENDSQL
SELECT
	r.id,
	r.type,
	r.file,
	r.status,
	r.size,
	r.date,
	r.comment AS `resource_comment`,
	a.comment
FROM
	`attachments` a
	INNER JOIN `resources` r
		ON r.id = a.resource_id
WHERE
	a.part_id = {$part_id}
ENDSQL
);

	$flag = false;
	while ( ($resource = $Db->fetch($rs)) !== false ) {
		if (($query_resource === $resource['id']) &&
			($resource['type'] != 'file')) {

			$sql = 'UPDATE `resources` SET `date` = NOW()';

			if (urlfilesize($resource['file'], $resource['size']) !== false ) {
				$sql .= ', `status` = \'ok\'';
				$resource['status'] = 'ok';

				if ($resource['type'] == 'remote') {
					$sql .= ', `size` = ';
					if ($resource['size'] === NULL) {
						$sql .= 'NULL';
					}
					else {
						$sql .= $Db->formatDecimal($resource['size']);
					}
				}
			}
			else {
				$sql .= ', `status` = \'404\'';
				$resource['status'] = '404';
			}

			$sql .= ' WHERE `id` = ' . $resource['id'] . ' LIMIT 1';
			$Db->query($sql);

			$resource['date'] = $Db->formatDate(time());
		}


		echo '<tr class="' . (($flag) ? 'even' : 'odd') . '">';
		$flag = !$flag;

		echo '<td>';

		if ($resource['resource_comment'] !== NULL) {
			echo '<img alt="Kommentar zur Ressource" src="images/12-resource.png" />' .
				htmlspecialchars($resource['resource_comment']) . '<br />';
		}

		echo htmlspecialchars($resource['comment']) . '</td>';
		echo '<td>';

		switch ($resource['type']) {
			case 'file':
				echo '<a href="download.php?id=' . $resource['id'] . '">' .
					htmlspecialchars($resource['file']) . '</a>';
				break;

			case 'remote':
				echo '<a href="' . htmlspecialchars($resource['file']) . '">' .
					'von extern</a>';
				break;

			case 'link':
				echo '<a href="' . htmlspecialchars($resource['file']) . '">' .
					'besuchen</a>';
				break;
		}

		echo '</td>';

		if ($resource['status'] == '404') {
			echo '<td style="font-weight: bold; color: red;">(404)';
		}
		else {
			echo '<td>';
			if ($resource['size'] !== NULL) {
				$magnitude = calculate_magnitude($resource['size'], 1024);
				echo format_decimal($resource['size'], 2) . ' ' . $magnitude . 'B';
			}
		}

		echo '</td><td>';

		$date = $Db->parseDate($resource['date']);
		echo htmlspecialchars(format_date($date));

		echo '</td><td>';

		if ($resource['type'] != 'file') {
			echo '<a href="' .
				$Url->build('query_resource', $resource['id']) . '">' .
				'<img alt="Aktualisieren" src="images/16-query.png" /></a>';
		}

		echo '</td></tr>';
	}

	$Db->free($rs);

?>

	</table>
</div>
