<?php

	if (!defined('IN_PARTS')) {
		exit;
	}




	abstract class Supplier {
		private static $instances = array();

		public static function instance($type) {
			if (isset(self::$instances[$type])) {
				return self::$instances[$type];
			}

			require_once 'suppliers/' . strtolower($type) . '.php';

			$class = $type . 'Supplier';
			$object = new $class();

			self::$instances[$type] = $object;
			return $object;
		}



		public abstract function findPrices($code);

		public abstract function formatCode($code, $html = false);

		public abstract function buildLink($code);
	}


?>