<?php

	if (!defined('IN_PARTS')) {
		exit;
	}

/*
	As of 5 January 2009.

	Example: Article code = 974903-62

	Articles are at:
		http://www.conrad.de/scripts/wgate/zcop_b2c/?
			~template=PCAT_PRODUCT_DETAILS_DOCUMENT&
			zhmmh_area_kz=48&
			product_show_id=125319&
			p_page_to_display=fromoutside

	These links won't work due to the brainfucked content management
	system. There are direct links that seem to work:
		http://www.conrad.de/goto.php?artikel=974903


*/


	class ConradSupplier {
		private $prices;
		private $artno;

		private function __construct($artno, $prices) {
			$this->artno = $artno;
			$this->price = $prices;
		}



		private function fromArtNo($artno) {
			$html = @file_get_contents(
				'http://www.conrad.de/scripts/wgate/zcop_b2c/?~template=PCAT_PRODUCT_DETAILS_DOCUMENT&zhmmh_area_kz=48&product_show_id='.
				$artno . '&p_page_to_display=fromoutside');

			if ($html === false) {
				return false;
			}
die($html);
			/* Try to find pricing */
			$doc = new DOMDocument();
			if (!$doc->loadHTML($html)) {
				return false;
			}


			/*
				Note that loadHTML won't create nodes for XHTML stuff
				such as tbody.
			*/
			$xpath = new DOMXpath($doc);
			$nodes = $xpath->query(
				'/html/body/table/tr[4]/td[2]/table/tr/td/table' /*.
				'/tr[4]/td/table/tr/td/table/tr/td/table'*/
			);

			if ($nodes->length == 0) {
				return false;
			}


			$node = $nodes->item(0);
			$raw = $node->nodeValue;
die($raw);
			/* Parse value */
			$raw = str_replace(',', '.', $raw);

			$result = preg_match(
				'/(([0-9][\\.])?[0-9]+)/is',
				$raw,
				$matches
			);

			if (!$result) {
				return false;
			}

			return new ReicheltSupplier(
				$artno,
				floatval($matches[1])
			);
		}

		public function create($code) {
			return self::fromArtNo($code);
		}



		public function prices() {
			return $this->prices;
		}

		public function buildLink() {
			return 'http://www.conrad.de/goto.php?artikel=' . $this->artno;
		}
	}


?>