<?php

	if (!defined('IN_PARTS')) {
		exit;
	}

/*
	As of 5 January 2009.

	Example: Article code = 1652441

	Articles are at:
		http://farnell.com/jsp/search/productdetail.jsp?SKU=1652441


*/


	class FarnellSupplier extends Supplier {
		private static function fromSKU($sku) {
			$html = @file_get_contents(
				'http://de.farnell.com/jsp/search/productdetail.jsp?SKU='. $sku
			);
die($html);
			if ($html === false) {
				return false;
			}

			/* Try to find pricing */
			$doc = new DOMDocument();
			if (!@$doc->loadHTML($html)) {
				return false;
			}


			/*
				Note that loadHTML won't create nodes for XHTML stuff
				such as tbody.
			*/
			$xpath = new DOMXpath($doc);
			$nodes = $xpath->query(
				'/html/body/table/tr[3]/td/table' .
				'/tr/td/table/tr/td/pftest:sku/table' .
				'/tr/td[4]/div[2]/table/tr[2]'
			);

			if ($nodes->length == 0) {
				return false;
			}


			$node = $nodes->item(0);
			$raw = $node->nodeValue;
die($raw);
			/* Parse value */
			$raw = str_replace(',', '.', $raw);

			$result = preg_match(
				'/(([0-9][\\.])?[0-9]+)/is',
				$raw,
				$matches
			);

			if (!$result) {
				return false;
			}

		}



		public function findPrices($code) {
			return self::fromSKU($code);
		}

		public function formatCode($code, $html = false) {
			return $code;
		}

		public function buildLink($code) {
			return 'http://farnell.com/jsp/search/productdetail.jsp?SKU=' . $code;
		}
	}


?>